
include \MASM32\INCLUDE\masm32rt.inc
WinMain proto :DWORD,:DWORD,:DWORD,:DWORD
MAINBITMAP		equ	500   ; BITMAP

.data
   	ClassName 		db "MainWinClass",0
   	AppName  		db "Main Window",0
   	ClassStatic		db	"Static",0
   	ClassButt		db	"Button",0
   	NameStatic1		db	"Mydraw1",0
	NameStatic2		db	"Mydraw2",0
   	hstatic1		dd	0
   	hstatic2		dd	0
   	hbutton			dd	0
   	hBit			dd	0
	hBit2			dd	0
	HTBit			dd	0
.data?
   hInstance 		HINSTANCE 	?
   CommandLine 		LPSTR 		?
.code
start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax	
	invoke GetCommandLine
	mov    CommandLine,eax
	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax
WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:HWND
	
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInstance
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_BTNFACE+1
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,OFFSET ClassName
	
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	
	invoke RegisterClassEx, addr wc
	
	INVOKE CreateWindowEx,WS_EX_CLIENTEDGE,ADDR ClassName,ADDR AppName,\
           WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,CW_USEDEFAULT,100h,100h,NULL,NULL,hInst,NULL
	mov   hwnd,eax
	invoke ShowWindow, hwnd,SW_SHOWNORMAL
	invoke UpdateWindow, hwnd
	
	.WHILE TRUE
		invoke GetMessage, ADDR msg,NULL,0,0
		.BREAK .IF (!eax)
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.ENDW
	mov     eax,msg.wParam
	ret
WinMain endp

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL   PS:PAINTSTRUCT
    LOCAL   hdc1:HDC
    LOCAL   hmem:HDC
    LOCAL   hBmpOrg2:DWORD
    LOCAL   hBmpOrg3:DWORD
	
	LOCAL	Bm:BITMAP
	LOCAL	ps:PAINTSTRUCT
	
	LOCAL	hdc10:HDC
	LOCAL	hMem10:HDC
	
	
	.IF uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
	.ELSEIF uMsg==WM_CREATE
		invoke	CreateWindowEx,NULL,addr ClassButt,addr AppName, WS_CHILD or WS_VISIBLE,60,48,80,40,hWnd,NULL,hInstance,NULL
		mov		hbutton,eax
		invoke	LoadBitmap,hInstance,MAINBITMAP
		mov		hBit,eax
		push	00FF00FFh			; color to tranparent
		push	eax					; hanlde to  bitmap
		call	CreateMask			
		mov		HTBit,eax			; save mask
	.elseif uMsg==WM_PAINT
	   	invoke	BeginPaint,hWnd,addr ps
	   	mov		hdc10,eax
	   	invoke	CreateCompatibleDC,hdc10
	   	mov		hMem10,eax
	   	invoke	SelectObject,hMem10,HTBit
	   	mov		hBmpOrg2,eax
	   	invoke	GetObject,hBit,sizeof Bm,addr Bm
	   	invoke	BitBlt,hdc10,0,0,Bm.bmWidth,Bm.bmHeight,hMem10,0,0,SRCAND
	   	invoke	SelectObject,hMem10,hBit
	   	mov		hBmpOrg3,eax
	   	invoke	BitBlt,hdc10,0,0,Bm.bmWidth,Bm.bmHeight,hMem10,0,0,SRCPAINT
	   	invoke	SelectObject,hMem10,hBmpOrg2
	   	invoke	DeleteDC,hMem10
	   	invoke	EndPaint,hWnd,addr ps
	.ELSE
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
		ret
	.ENDIF
	
	xor eax,eax
	ret
WndProc endp


;b =255
;g =0 
;r =255
;result = 00FF00FFh

;param1:	HBITMAP  = (DWORD)			:	hColour
;param2:	COLORREF =0x00bbggrr (DWORD): 	transparent

param1	equ	[ebp+08h]
param2	equ	[ebp+0ch]

CreateMask	proc
	LOCAL	HDC1:HDC
	LOCAL	HDC2:HDC
	LOCAL	hBMask:HBITMAP
	LOCAL	Bm:BITMAP
	
	invoke	GetObject,param1,sizeof(BITMAP),addr Bm
	invoke	CreateBitmap,Bm.bmWidth,Bm.bmHeight,1,1,NULL
	mov		hBMask,eax
	
	invoke	CreateCompatibleDC,0
	mov		HDC1,eax
	invoke	CreateCompatibleDC,0	
	mov		HDC2,eax
	
	invoke	SelectObject,HDC1,param1
	invoke	SelectObject,HDC2,hBMask
	
	invoke	SetBkColor,HDC1,param2
	
	invoke	BitBlt,HDC2,0,0,Bm.bmWidth,Bm.bmHeight,HDC1,0,0,SRCCOPY
	invoke	BitBlt,HDC1,0,0,Bm.bmWidth,Bm.bmHeight,HDC2,0,0,DSTINVERT
	
	invoke	DeleteDC,HDC1
	invoke	DeleteDC,HDC2
	
	mov		eax,hBMask
	ret		08h
CreateMask 	endp

end start


